
/**
 * SpectraDataFormat_1.java
 * This interface is used to add support for spectra data 1
 *
 * Created: Mar 6 2004
 *
 * @author Nathan Stevens
 * @version 0.1 3/13/04
 */
import java.io.*;
import java.util.*;

public interface SpectraDataFormat_1 {
  
  // Method to set the name of the data
  String getName();
  void setName(String name);
  
  // Method to get and set the header information
  String[] getHeader();
  void setHeader(String[] header);
  
  // Method to get and set Meta information about the data
  String[] getMetaInfo();
  void setMetaInfo(String[] mi);
  
  // Method to get and set the data
  float[][] getData();
  void setData(float[][] data);
  
  // Method to get and set the reference data
  float[][] getReferenceData();
  void setReferenceData(float[][] data);
  
  // Method to see if data has a reference data
  boolean hasRef();
  
  // Method to get and set the type of data
  String getType();
  void setType(String type);
  
  // Method to get and set the column labels
  String[] getColumnLabels();
  void setColumnLabels(String xlabel, String ylabel);
  
  // Methods to set whether or not to export the xlabel, and column.
  boolean exportX();
  void setExportX(boolean b);
  
  // Method to see if data is 3D or not
  boolean is3D();
  void set3D(boolean b);
  
  // set whether the data is a profile from 3D data
  boolean isProfile();
  void setProfile(boolean b);
  
  // Method to set the direction the profile.  time or wavelength
  int getProfileDirection();
  void setProfileDirection(int d);
  
  // Method to get and set the delay.
  String getDelay();
  void setDelay(String delay);
  
  // Method to get the size of the data
  int size();
  
  // Method to get a and set a list of Attachments URL
  Vector getAttachmentURL();
  void setAttachmentURL(Vector urls);
  
  // Method to get and set a list of keywords for seaching purposes
  Vector getKeywords();
  void setKeywords(Vector keywords);
  
  // Method to see if the data is shared
  boolean isShared();
  void setShared(boolean b);
  
  // Method to set and get a password
  String getPassword();
  void setPassword(String pw);
  
  // Method to get the binary file version this is
  int getVersion();
  
  // Method to get the string representation of the data
  String toString();
}//--SpectraDataFormat_1
